' Phone Book
Strict
Framework brl.blitz
Import Thunder.ObjectEx

Type TContact
	Global oex:ObjectEx = ObjectEx.Create(New TContact)
	
	Field phone_nr:String
	Field first_name:String, last_name:String
	Field age
	
EndType

Local c:TContact, i:ObjectExIdent, s:String

Repeat
	Print
	Print
	Print "(1) New Contact"
	Print "(2) Show All Contacts"
	Print "(3) Modify Contact"
	Print "(4) Delete Contact"
	Print "(0) Quit"
	Print
	Select Int(Input())
	Case 1
		c = New TContact
		c.phone_nr = Input("Phone: ")
		If TContact.oex.add(c.phone_nr, c) Then
			Print "Contact created!"
		Else
			Print "Contact with same Number already exists!"
		EndIf
		
	Case 2
		For c = EachIn TContact.oex.Objs()
		
			For i = EachIn TContact.oex.Fields()
			
				If i.typ = "$" Then
					Print i.name+": "+String(IntToObject(i.get(c)))
				Else
					Print i.name+": "+i.get(c)
				EndIf
				
			Next
			
		Next
		
	Case 3
		c = TContact(TContact.oex.Obj(Input("Phone: ")))
		If c Then
		
			Write "Properties: "
			For i = EachIn TContact.oex.Fields()
				Write i.name+" "
			Next
			Print

			Print "Empty line returns you to main menu."			
			Repeat
				s = Input("Property to change: ")
				i = TContact.oex.Identifier(s)
				If i Then
					If i.typ = "$" Then
						i.set c, ObjectToInt(Input("Value: "))
					Else
						i.set c, Int(Input("Value: "))
					EndIf 
					Print "Changed!"
				ElseIf Not s
					Exit
				Else
					Print "No such Property!"
				EndIf
			Forever
			
		Else
			Print "No such Contact!"
		EndIf
		
	Case 4
		s = Input("Phone: ")
		If TContact.oex.Obj(s) Then
			TContact.oex.Remove s
			Print "Removed!"
		Else
			Print "No such Contact!"
		EndIf
	Case 0
		End
	EndSelect
Forever

Function Input$(prompt$ = ">")
	Write prompt
	Return ReadStdin().Trim()
EndFunction

Function Write(s$)
	WriteStdout s
EndFunction

Function Print(s$ = "")
	Write s+"~n"
EndFunction