' Two Types pointing at each other
Strict
Framework brl.standardio
Import Thunder.ObjectEx

Type TB
	Field p:TA
	Field x
EndType

Type TA
	Field p:TB
	Field x
EndType

Global A:TA = New TA, A2:TA
Global B:TB = New TB

A.p = B
B.p = A

A.x = 42
A.p.x = 42

A2 = TA(CopyObjectTree(A))
' This will also Copy B, so you will not be able to access
' the original B via A2, but a copy of it:

A2.p.x = 0

Print A.x
Print A.p.x
Print

' Instead of using CopyObjectTree on such Objects, use
' CopyObject only whenever possible:

A2 = TA(CopyObject(A))

A2.p.x = 0
A2.x = 0

Print A.x
Print A.p.x